//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop
#include "pvmain.h"
#include "..\pv650x.h"
#include "..\Fpga_Reg.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Chart"
#pragma link "TeEngine"
#pragma link "TeeProcs"
#pragma link "CSPIN"
#pragma link "pies"
#pragma link "PERFGRAP"
#pragma resource "*.dfm"

 TForm1 *Form1;
 char a;
 DWORD pv = 0;

 OSCCTRL oscctrl;
 UCHAR A1[ MAX_BUF_LENGTH ];
 UCHAR A2[ MAX_BUF_LENGTH ];
 UCHAR D1[ MAX_BUF_LENGTH ];
 UCHAR D2[ MAX_BUF_LENGTH ];
 OSC osc;

//---------------------------------------------------------------------------
//  
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
/*
================================================================================

================================================================================
*/
void __fastcall TForm1::LogDblClick(TObject *Sender)
{
  Log->Lines->Clear( );
}
/*
================================================================================

================================================================================
*/
void __fastcall TForm1::BtnOpenClick(TObject *Sender)
{
  PV_SERIAL_LIST devlist;

  a = pv_List( devlist );

  Log->Lines->Add( "  PV650X:" );
  for ( int i = 0 ; i < a ; i++ )
  {
    AnsiString str; str = devlist[ i ];
    Log->Lines->Add("#" + IntToStr( i )+ ": " + str );
  }
  Log->Lines->Add( ": " + IntToStr( ( int ) a ) );

  if ( a == 0 ) return;

  Log->Lines->Add(" #0: " ); 
  int err = pv_Open( devlist[ 0 ] , &pv );
  if(err < 0)   Log->Lines->Add(""); else
  Log->Lines->Add("  : " + IntToStr( ( __int64 ) pv ) );
  BtnApply->Enabled = true;


}
/*
================================================================================
                        
================================================================================
*/
void __fastcall TForm1::BtnApplyClick(TObject *Sender)
{
  if ( !pv ) return;

  POSC p_osc = ( POSC ) malloc( sizeof( OSC ) );

  p_osc->trig_mode.auto_restart = CBCont->Checked;
  p_osc->trig_mode.neg_sync     = CBNegSync->Checked;
  p_osc->trig_mode.auto_sync    = CBAuto->Checked;
  //----------------------------------------------------------------------------
  p_osc->trig_cond.data = 0;
  if ( CBTrigCondA1->ItemIndex > 0 )
  {
    p_osc->trig_cond.A1_enb = true;
    p_osc->trig_cond.A1_lev = CBTrigCondA1->ItemIndex - 1;
  }

  if ( CBTrigCondA2->ItemIndex > 0 )
  {
    p_osc->trig_cond.A2_enb = true;
    p_osc->trig_cond.A2_lev = CBTrigCondA2->ItemIndex - 1;
  }

  if ( CBTrigCondD1->ItemIndex > 0 )
  {
    p_osc->trig_cond.D1_enb = true;
    p_osc->trig_cond.D1_lev = CBTrigCondD1->ItemIndex - 1;
  }

  if ( CBTrigCondD2->ItemIndex > 0 )
  {
    p_osc->trig_cond.D2_enb = true;
    p_osc->trig_cond.D2_lev = CBTrigCondD2->ItemIndex - 1;
  }
  //----------------------------------------------------------------------------

  p_osc->adc_mode.peak_detect   = CBPeak->Checked;
  p_osc->adc_mode.select_A1     = CBEnbA1->Checked;
  p_osc->adc_mode.select_A2     = CBEnbA2->Checked;
  p_osc->adc_mode.select_D1     = CBEnbD1->Checked;
  p_osc->adc_mode.select_D2     = CBEnbD2->Checked;
  p_osc->adc_mode.close_in_A1   = CBClose1->Checked;
  p_osc->adc_mode.close_in_A2   = CBClose2->Checked;

  p_osc->trig_mode.trig_src = 0;
  if ( RBA1->Checked ) p_osc->trig_mode.trig_src = TRIG_A1;
  if ( RBA2->Checked ) p_osc->trig_mode.trig_src = TRIG_A2;
  if ( RBD1->Checked ) p_osc->trig_mode.trig_src = TRIG_D1;
  if ( RBD2->Checked ) p_osc->trig_mode.trig_src = TRIG_D2;
  if ( RBNoSync->Checked ) p_osc->trig_mode.trig_src = TRIG_DSB;

  p_osc->smpl_per       = CSSample->Value;
  p_osc->smpl_pre       = CSPre->Value;
  p_osc->smpl_post      = CSPost->Value;
  p_osc->zero_A1        = CSZero1->MaxValue - CSZero1->Value;
  p_osc->zero_A2        = CSZero2->MaxValue - CSZero2->Value;

  p_osc->trig_lev_A1    = CSTrigLev1->Value;
  p_osc->trig_lev_A2    = CSTrigLev2->Value;
  p_osc->trig_gist_A1   = CSTrigGist1->Value;
  p_osc->trig_gist_A2   = CSTrigGist2->Value;
  p_osc->trig_numb      = CSTrigN->Value;

  p_osc->min_P          = CSTrigMinT->Value;
  p_osc->max_P          = CSTrigMaxT->Value;
  p_osc->trig_mode.sync_pt      = CBPT_Sync->Checked;
  p_osc->trig_mode.sync_pt_in   = CBPT_Inside->Checked;

  p_osc->trig_slew      = CSTrigS->Value;
  p_osc->trig_mode.sync_st      = CBST_Sync->Checked;
  p_osc->trig_mode.sync_st_less = CBST_Less->Checked;

  p_osc->fps            = 25;
  p_osc->fmetr_in       = CBFmetrIn->ItemIndex;
  //----------------------------------------------------------------------------
  p_osc->att_A1         =  CBAtt1->ItemIndex;
  p_osc->att_A2         =  CBAtt2->ItemIndex;
  //----------------------------------------------------------------------------
  //                     
  //----------------------------------------------------------------------------
  p_osc->gen_enable     = CBGenEnb->Checked;
  p_osc->gen_mode       = CBGenMode->ItemIndex;
  p_osc->gen_freq       = ( ( double ) CSGenFreq->Value )    / 10.0;   // 0.1
  p_osc->gen_mod_K      = CSGenModK->Value;                            // 0.1%
  p_osc->gen_mod_freq   = ( ( double ) CSGenModFreq->Value ) / 10.0;   // 0.1
  p_osc->gen_swip_span  = ( ( double ) CSGenSpan->Value )    / 10.0;
  p_osc->gen_pulse_T    = CSGenFreq->Value;
  p_osc->gen_pulse_D    = CSGenPulseD->Value;


  p_osc->gen_ampl       = CSGenAmpl->Value;
  p_osc->gen_shape      = CBGenShape->ItemIndex;
  p_osc->gen_mod_shape  = CBGenModShape->ItemIndex;
  p_osc->gen_mod_in     = CBGenModIn->ItemIndex;
  p_osc->gen_mod_invert = CBGenModInvert->Checked;
  p_osc->gen_mod_zero1  = CSGenModZero1->Value;
  p_osc->gen_mod_zero2  = CSGenModZero2->Value;
  p_osc->gen_pulse_D    = CSGenPulseD->Value;
  //----------------------------------------------------------------------------
  pv_PutAllReg( &pv , p_osc );
  free( p_osc );

}
/*
================================================================================
                              
================================================================================
*/
void __fastcall TForm1::PutWaveform  ( PUCHAR buf , USHORT len , TColor color ,
                                      USHORT mark , bool * flags , int K , int bias )
{
 bool minmax  = flags[ 0 ];
 bool eq_end  = flags[ 1 ];
 bool eq_flag = flags[ 2 ];
 PaintBox1->Canvas->Pen->Color = color;              //

  double dy = ( ( double ) PaintBox1->Height / 254.0 ) * ( double ) K ;
  double dx =   ( double ) PaintBox1->Width  / ( double )len;  //   
  if ( minmax ) dx *= 2.0;

 if ( mark )
 {
   //     
   if ( eq_flag == false ) mark = len;
   if ( ( eq_flag == true ) && ( eq_end == false ) )
       setmem ( buf + mark , len - mark , 0xFF ); //    
 }

 if ( minmax )
 {
   len  /= 2; // . .    
   mark /= 2; //    
 }

  double Height = ( double ) PaintBox1->Height - bias;

  double x = 0;
  double y = ( double ) Height - 1.0 - ( ( double ) *buf ) * dy ;

  PaintBox1->Canvas->MoveTo( 0, ( int ) y );     //  
  //  
  for ( USHORT i = 0 ; i < len ; i++ )
  {
    if ( *buf != 0xFF )
    {
      y = Height - 1.0 - ( double )*buf  * dy ;
      if ( minmax )
      {
        PaintBox1->Canvas->MoveTo( ( int ) x  ,  ( int ) y ); // 
        PaintBox1->Canvas->Pixels[ ( int ) x ] [ ( int ) y ] = color;
        buf++;
        y = Height - 1.0 - ( double )*buf  * dy ;
      }

      PaintBox1->Canvas->LineTo( ( int ) x , ( int ) y );
    }
    if ( ( mark ) && ( i == mark ) )    //   
    {
      PaintBox1->Canvas->Pen->Color = clGray; //  ""
      //     
      PaintBox1->Canvas->MoveTo( ( int ) x  ,( int ) 0 );
      PaintBox1->Canvas->LineTo( ( int ) x  , PaintBox1->Height );
      PaintBox1->Canvas->MoveTo( ( int ) x  ,( int ) y );
    }
    buf++;
    x += dx;
  }
}
/*
================================================================================
                       
================================================================================
*/
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  static int TimerPrc = 0;
  int len;
  bool flags[ 3 ];
  //----------------------------------------------------------------------------
  AnsiString trig_data = "";
  AnsiString trig_fine = "";
  AnsiString trig_p    = "";
  AnsiString trig_s    = "";
  AnsiString f_str = "F = ...";
  //----------------------------------------------------------------------------
  int res = pv_GetData( &pv , A1 , A2 , D1 , D2 , &osc , &oscctrl );
  //----------------------------------------------------------------------------
  if ( res <= PV_NO_DATA )
  {
    Pie1->Angles->StartAngle = 0;
    Pie1->Angles->EndAngle   = 0;
    LbConfig->Font->Color = clRed;
    LbConfig->Caption = " ";
    return;
  }
  //----------------------------------------------------------------------------
  if ( res & PV_PRESENT_CTRL )
  {
    LbVerFPGA->Caption = " FPGA: "
                                  + IntToStr(   oscctrl.FPGA_ver / 100 ) + "."
                            + IntToStr( ( oscctrl.FPGA_ver / 10 ) % 10 )
                                  + IntToStr(   oscctrl.FPGA_ver  % 10 );
    LbVerFW->Caption   = " : "
                                  + IntToStr(   oscctrl.firm_ver / 100 ) + "." 
                            + IntToStr( ( oscctrl.firm_ver / 10 ) % 10 )
                                  + IntToStr(   oscctrl.firm_ver  % 10 );
    LbUcc->Caption     =  ": " +
                           FloatToStrF( ( float ) oscctrl.Vcc_Scope / 100,
                           ffFixed, 15, 2) + " ";

    switch( oscctrl.pv_type )
    {
    case TYPE_PV6501A: LbPvType->Caption = ": PV6501A";
      break;
    case TYPE_PV6502: LbPvType->Caption = ": PV6502";
      break;
    case TYPE_PV6503: LbPvType->Caption = ": PV6503";
      break;
    }

    if ( ++TimerPrc > 360 ) TimerPrc = 0;
    Pie1->Angles->StartAngle = 0;
    Pie1->Angles->EndAngle   = TimerPrc;
  }
  //----------------------------------------------------------------------------
  if ( res & PV_UNCONFIG )
  {
    Pie1->Brush->Color    = clYellow;
    LbConfig->Font->Color = clYellow;
    LbConfig->Caption = " ";
    return;
  }
  //----------------------------------------------------------------------------
  if ( !( res & PV_PRESENT_OSC ) ) return;
  //----------------------------------------------------------------------------
  if ( res & PV_CONFIGURED )
  {
    CSPre->Value  = ( ( USHORT ) CSPre-> Value > osc.smpl_pre ) ?
                    ( osc.smpl_pre ): ( CSPre->Value );
    CSPost->Value = ( ( USHORT ) CSPost->Value > osc.smpl_pre ) ?
                    ( osc.smpl_post ): ( CSPost->Value );
    CSPost->Value = osc.smpl_post;
    Pie1->Brush->Color    = clGreen;
    LbConfig->Font->Color = clGreen;
    LbConfig->Caption = "";
  }
  //--------------------------------------------------------------------------
  if ( osc.f_valid ) f_str.printf( "F = %9.5f " , osc.freq  );

  LbPointNum->Caption = " : " + IntToStr( osc.smpl_pre ) +
                    " + " + IntToStr( osc.smpl_post ) +
                    " = " + IntToStr( osc.smpl_post + osc.smpl_pre );
  //----------------------------------------------------------------------------
  len = osc.smpl_pre + osc.smpl_post;
  if ( ( res & PV_PRESENT_ALL_DATA ) && ( len > 0 ) )
  {
    //     
    ClearPaintBox (  );
    //--------------------------------------------------------------------------
    USHORT mark  = 0;                //   
    flags[ 0 ] =  osc.adc_mode.peak_detect;
    //--------------------------------------------------------------------------
    if ( osc.trig_mode.auto_restart )       // 
    {
      flags[ 1 ] = osc.end_flag;
      flags[ 2 ] = osc.eq_flag;
      mark       = osc.addr_eq;             // 
    }
    if ( res & PV_PRESENT_A1 ) PutWaveform( A1 , len , clRed   , mark , flags , 1 ,  0  );
    if ( res & PV_PRESENT_A2 ) PutWaveform( A2 , len , clGreen , mark , flags , 1 ,  0  );
    if ( res & PV_PRESENT_D1 ) PutWaveform( D1 , len , clBlue  , mark , flags , 20 , 10 );
    if ( res & PV_PRESENT_D2 ) PutWaveform( D2 , len , clPurple, mark , flags , 20 , 50 );
    //--------------------------------------------------------------------------
    if ( res & ( PV_PRESENT_A1 | PV_PRESENT_A2 ) )
    {
      trig_data.printf( "   .: %u   %u " ,
                         osc.before_V , osc.after_V );
      trig_fine.printf( "  : + %u x 10 " , osc.trig_fine_pos );
      trig_p.printf( " : %d x 10" , osc.trig_P );
      trig_s.printf( " : %d" , osc.trig_S );
    }
    //--------------------------------------------------------------------------
    if ( osc.trig_numb != 0 || osc.adc_mode.select_A2 || osc.adc_mode.select_D2 )
    {
      PaintBox1->Canvas->Pen->Color = clGray;
      int x_trig = ( PaintBox1->Width *  osc.smpl_pre ) / len;
      PaintBox1->Canvas->MoveTo( x_trig , 0 );
      PaintBox1->Canvas->LineTo( x_trig , PaintBox1->Height );
    }
    LBTrigData->Caption = trig_data;
    LBTrigFine->Caption = trig_fine;
    LbTrigP->Caption = trig_p;
    LbTrigS->Caption = trig_s;
  }
  PaintBox1->Canvas->Refresh( );
  LbFmetr->Caption    = f_str;
}

/*
================================================================================
                             
================================================================================
*/
void GetFileVer( char* file , char* ver )
{
  DWORD h;
  DWORD size = GetFileVersionInfoSize( file , &h );
  if(size == 0) return ;
  char *buf;
  buf = (char *) GlobalAlloc ( GMEM_FIXED , size );
  if ( GetFileVersionInfo( file , h , size , buf ) != 0 )
  {
    char *ValueBuf;
    UINT Len;
    VerQueryValue( buf, "\\VarFileInfo\\Translation" , &(void *)ValueBuf , &Len );
    if (Len>=4)
    {
      AnsiString CharSet=IntToHex((int )MAKELONG(*(int *)(ValueBuf+2),*(int *)ValueBuf), 8);

      if ( VerQueryValue( buf ,
           AnsiString( "\\StringFileInfo\\" + CharSet + "\\FileVersion").c_str() ,
           &( void * )ValueBuf , &Len )!=0 )

        strncpy( ver , ValueBuf  , 64);
    }
  }
  GlobalFree(buf);
}

/*
================================================================================
                            
================================================================================
*/
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Log->Lines->Clear( );
  RBSelClick( this );
  CBGenModeChange( this );
  Form1->BorderStyle = bsSingle;


  char ver[ 64 ];
  GetFileVer( Application->ExeName.c_str() , ver );
  Log->Lines->Add(  " : "  + AnsiString ( ver ) );

  ver[ 0 ] = '\0';
  AnsiString dll_name = AnsiString ( ExtractFilePath ( Application->ExeName ) +
                           "pv650x.dll" );

  GetFileVer( dll_name.c_str() , ver );
  Log->Lines->Add(  " DLL: "  + AnsiString ( ver ) );
}
/*
================================================================================
     RadioButton c   
================================================================================
*/
void __fastcall TForm1::RBSelClick(TObject *Sender)
{
  static UCHAR TrigN = 1;
  if( RBNoSync->Checked )
  {
    TrigN = CSTrigN->Value;
    CSTrigN->Value = 0;
    CSTrigN->Enabled = false;
  }
  else
  {
    CSTrigN->Value = TrigN;
    CSTrigN->Enabled = true;
  }
  PutTrigInfo(  );

}
/*
================================================================================
                         
================================================================================
*/
void __fastcall TForm1::PutTrigInfo(  )
{
  TRect rect;

  PaintBox2->Canvas->Brush->Color = clWhite;
  rect = Rect(Point(0, 0), Point(PaintBox2->Width, PaintBox2->Height));
  PaintBox2->Canvas->FillRect(rect);

  PaintBox2->Canvas->Pen->Color = clGray;
  PaintBox2->Canvas->Rectangle(rect);

  if ( RBA1->Checked || RBA2->Checked )
  {
    int trig_val;
    int trig_gist;

    if ( RBA1->Checked )
    {
      trig_val  = CSTrigLev1->Value;
      trig_gist = CSTrigGist1->Value;
    }
    else
    {
      trig_val  = CSTrigLev2->Value;
      trig_gist = CSTrigGist2->Value;
    }

    trig_val = trig_val;
    trig_gist /= 2;

    double y_trig = ( double ) PaintBox2->Height - ( ( double ) PaintBox2->Height / 255.0 ) *
                                         ( double ) trig_val;

    double y_gist = ( ( double ) PaintBox2->Height / 255.0 ) *
                                          ( double ) trig_gist;

    PaintBox2->Canvas->Pen->Color = clBlue;

    PaintBox2->Canvas->MoveTo(    0 , ( int )y_trig );
    PaintBox2->Canvas->LineTo(   10 , ( int )y_trig );

    PaintBox2->Canvas->Rectangle( 0 , ( int )y_trig - ( int )y_gist ,
                                  5 , ( int )y_trig + ( int )y_gist );
  }
}
/*
================================================================================
                        
================================================================================
*/
void __fastcall TForm1::CSTrigChange(TObject *Sender)
{
  CSpinEditChange( Sender );
  PutTrigInfo(  );
}
/*
================================================================================
                           
================================================================================
*/
void __fastcall TForm1::BtnCloseClick(TObject *Sender)
{
  pv_Close( &pv );
  BtnApply->Enabled = false;
}
/*
================================================================================
                            PaintBox
================================================================================
*/
void __fastcall TForm1::ClearPaintBox (  )
{
  PaintBox1->Canvas->Brush->Color = clWhite;
  TRect rect;
  rect = Rect(Point(0, 0), Point(PaintBox1->Width, PaintBox1->Height));
  PaintBox1->Canvas->FillRect(rect);
}
/*
================================================================================
                   CSpinEdit
================================================================================
*/
//------------------------------------------------------------------------------
//                 
//------------------------------------------------------------------------------
void __fastcall TForm1::CSpinEditPress(TObject *Sender, char &Key)
{
  TCSpinEdit * SpinEdit = ( TCSpinEdit *) Sender;

  if ( Key == '\b' ) return;
  if ( Key == '\r' ||  Key < '0' || Key > '9' )
  {
    BtnApplyClick( this );
    Key = 0;
  }
  if ( SpinEdit->Value == 0 )
  {
    SpinEdit->Value = Key - '0';
    SpinEdit->SelStart = SpinEdit->Text.Length();
    Key = 0;
  }
}
//------------------------------------------------------------------------------
//              , 
//------------------------------------------------------------------------------
void __fastcall TForm1::CSpinEditChange(TObject *Sender)
{
  TCSpinEdit * SpinEdit = ( TCSpinEdit * ) Sender;

  if ( SpinEdit->Text == "" ) SpinEdit->Value = SpinEdit->MinValue;

  unsigned __int64 value = ( unsigned __int64 ) SpinEdit->Text.ToDouble( );

  SpinEdit->Value = value;   //    
  if ( value > SpinEdit->MaxValue )
  {
    SpinEdit->Value = SpinEdit->MaxValue;
    SpinEdit->SelStart = SpinEdit->Text.Length( );
  }
}
/*
================================================================================
                      
================================================================================
*/
void __fastcall TForm1::CBGenModeChange(TObject *Sender)
{
  CSGenSpan->Enabled      = false;
  CSGenModFreq->Enabled   = false;
  CSGenModZero1->Enabled  = false;
  CSGenModZero2->Enabled  = false;
  CSGenModK->Enabled      = false;
  CSGenPulseD->Enabled    = false;

  CBGenModInvert->Enabled = false;
  CBGenModIn->Enabled     = false;
  CBGenShape->Enabled     = true;
  CBGenModShape->Enabled  = false;

  LbSwipPulse->Enabled    = false;
  LbModFreq->Enabled      = false;
  LbGenModIn->Enabled     = false;
  LbGenZeroA1->Enabled    = false;
  LbGenZeroA2->Enabled    = false;
  LbGenModShape->Enabled  = false;
  LbPulse->Enabled        = false;
  LbGenModK->Enabled      = false;
  LbGenShape->Enabled     = true;

  LbGenFreq->Caption = "  x 0.1";

  switch ( CBGenMode->ItemIndex )
  {
  // 
  case GEN_MODE_CW:
    break;
  // 
  case GEN_MODE_SWIP:
    CSGenSpan->Enabled   = true;
    LbSwipPulse->Enabled = true;
    break;
  // AM
  case GEN_MODE_AM:
      LbGenModK->Caption = "  x 0.1%";
      CSGenModK->MaxValue = 1000; // 100.0% * 10 
  // 
  case GEN_MODE_SUM:
    if ( CBGenMode->ItemIndex == GEN_MODE_SUM )
    {
      LbGenModK->Caption = "  x 0.1%";
    }
  // FM
  case GEN_MODE_FM:
    CSGenModKChange( this );
    if ( CBGenMode->ItemIndex == GEN_MODE_FM )
    {
      CSGenModK->MaxValue = GEN_FM_MAX_UINT;
    }
    LbModFreq->Enabled      = true;
    LbGenModIn->Enabled     = true;
    LbGenModK->Enabled      = true;
    CSGenModK->Enabled      = true;
    CBGenModIn->Enabled     = true;
    CBGenModInvert->Enabled = true;

    if ( CBGenModIn->ItemIndex != 0 )
    {
      LbGenZeroA1->Enabled    = true;
      LbGenZeroA2->Enabled    = true;
      CSGenModZero1->Enabled  = true;
      CSGenModZero2->Enabled  = true;
    }else
    {
      CSGenModFreq->Enabled   = true;
      LbGenModShape->Enabled  = true;
      CBGenModShape->Enabled  = true;
    }
    break;
  // 
  case GEN_MODE_PULSE:
    LbGenFreq->Caption = "  x 10 ";
    LbPulse->Enabled      = true;
    CSGenPulseD->Enabled  = true;
    CBGenShape->Enabled   = false;
    LbGenShape->Enabled   = false;
    break;
  }
}
/*
================================================================================
                          -
================================================================================
*/
void __fastcall TForm1::CSGenModKChange(TObject *Sender)
{
  CSpinEditChange( this->CSGenModK );
  if ( CBGenMode->ItemIndex == GEN_MODE_FM )
  {
    AnsiString  f_dev_str;
    f_dev_str.printf( "  = %4.2f " ,
                      ( ( double ) CSGenModK->Value * 1.48939 ) );
    LbGenModK->Caption = f_dev_str;
  }
}






